import { NodeMaterialBlock } from "../nodeMaterialBlock.js";
import type { NodeMaterialBuildState } from "../nodeMaterialBuildState.js";
import type { NodeMaterialConnectionPoint } from "../nodeMaterialBlockConnectionPoint.js";
import type { NodeMaterial } from "../nodeMaterial.js";
import "../../../Shaders/ShadersInclude/fresnelFunction.js";
/**
 * Block used to compute fresnel value
 */
export declare class FresnelBlock extends NodeMaterialBlock {
    /**
     * Create a new FresnelBlock
     * @param name defines the block name
     */
    constructor(name: string);
    /**
     * Gets the current class name
     * @returns the class name
     */
    getClassName(): string;
    /**
     * Gets the world normal input component
     */
    get worldNormal(): NodeMaterialConnectionPoint;
    /**
     * Gets the view direction input component
     */
    get viewDirection(): NodeMaterialConnectionPoint;
    /**
     * Gets the bias input component
     */
    get bias(): NodeMaterialConnectionPoint;
    /**
     * Gets the camera (or eye) position component
     */
    get power(): NodeMaterialConnectionPoint;
    /**
     * Gets the fresnel output component
     */
    get fresnel(): NodeMaterialConnectionPoint;
    autoConfigure(material: NodeMaterial): void;
    protected _buildBlock(state: NodeMaterialBuildState): this;
}
