import { NodeParticleBlock } from "../nodeParticleBlock.js";
import type { NodeParticleConnectionPoint } from "../nodeParticleBlockConnectionPoint.js";
import { ParticleRandomBlockLocks } from "./particleRandomBlock.js";
/**
 * Block used to pick a value randomly from a range
 */
export declare class RandomRangeBlock extends NodeParticleBlock {
    private _currentLockId;
    /**
     * Gets or sets a value indicating if that block will lock its value for a specific event
     */
    lockMode: ParticleRandomBlockLocks;
    /**
     * Create a new RandomRangeBlock
     * @param name defines the block name
     */
    constructor(name: string);
    /**
     * Gets the min input component
     */
    get min(): NodeParticleConnectionPoint;
    /**
     * Gets the max input component
     */
    get max(): NodeParticleConnectionPoint;
    /**
     * Gets the output component
     */
    get output(): NodeParticleConnectionPoint;
    /**
     * Gets the current class name
     * @returns the class name
     */
    getClassName(): string;
    /**
     * Builds the block
     */
    _build(): void;
    /**
     * Serializes this block in a JSON representation
     * @returns the serialized block object
     */
    serialize(): any;
    _deserialize(serializationObject: any): void;
}
